#include "Bullet.h"

CBullet* bullet;

CBullet::CBullet()
{
	memset(tShot, 0, sizeof(SHOT_PARAM) * SHOT_MAX);
	for(int ii = 0; ii < SHOT_MAX; ii++)
	{
		/*for(int jj = 0; jj < SHOT_BULLET_MAX; jj++)
		{
			tShot[ii].tBullet[jj].Pos.y = -280.0f;
		}*/
	}
	memset(&PlayerInfo, 0, sizeof(PlayerInfo));
	ShotBulletPattern[0] = &CBullet::ShotBulletPattern000;
	ShotBulletPattern[1] = &CBullet::ShotBulletPattern001;
	ShotBulletPattern[2] = &CBullet::ShotBulletPattern002;
	ShotBulletPattern[3] = &CBullet::ShotBulletPattern003;
	ShotBulletPattern[4] = &CBullet::ShotBulletPattern004;
	ShotBulletPattern[5] = &CBullet::ShotBulletPattern005;
	ShotBulletPattern[6] = &CBullet::ShotBulletPattern006;
}
CBullet::~CBullet()
{}
//----------------------------------------------------------------
void CBullet::LoadBullet()
{
	LoadDivGraph("./Bullet/b0.png" , 5 , 5 , 1 , 76 , 76 , BulletImage[0]) ;
    LoadDivGraph("./Bullet/b1.png" , 6 , 6 , 1 , 22 , 22 , BulletImage[1]) ;
    LoadDivGraph("./Bullet/b2.png" , 10 , 10 , 1 , 5 , 120 , BulletImage[2]) ;
    LoadDivGraph("./Bullet/b3.png" , 5 , 5 , 1 , 19 , 34 , BulletImage[3]) ;
    LoadDivGraph("./Bullet/b4.png" , 10 , 10 , 1 , 38 , 38 , BulletImage[4]) ;
    LoadDivGraph("./Bullet/b5.png" , 3 , 3 , 1 , 14 , 16 , BulletImage[5]) ;
    LoadDivGraph("./Bullet/b6.png" , 3 , 3 , 1 , 14 , 18 , BulletImage[6]) ;
    LoadDivGraph("./Bullet/b7.png" , 9 , 9 , 1 , 16 , 16 , BulletImage[7]) ;
    LoadDivGraph("./Bullet/b8.png" , 10 , 10 , 1 , 12 , 18 ,BulletImage[8]) ;
    LoadDivGraph("./Bullet/b9.png" , 3 , 3 , 1 , 13 , 19 , BulletImage[9]) ;
}
//----------------------------------------------------------------
void CBullet::SetEnemyParam(CEnemy::ENEMY_PARAM* enemy)
{
	EnemyInfo = enemy;
}
//----------------------------------------------------------------
void CBullet::SetPlayerParam(CModel::PLAYER_PARAM player)
{
	PlayerInfo = player;
}
//----------------------------------------------------------------
float CBullet::Shotatan2(int ShotNumber)
{
	return atan2(PlayerInfo.PlayerPos.z - EnemyInfo[tShot[ShotNumber].Number].Pos.z, PlayerInfo.PlayerPos.x - EnemyInfo[tShot[ShotNumber].Number].Pos.x);
}
//----------------------------------------------------------------
//󂢂ĂeT
int CBullet::ShotSearch(int ShotNumber)
{
	for(int ii = 0; ii < SHOT_BULLET_MAX; ii++)
	{
		if(tShot[ShotNumber].tBullet[ii].Flag == 0)
		{
			return ii;
		}
	}
	return -1;
}
//----------------------------------------------------------------
void CBullet::ShotMain()
{
	for(int ii = 0; ii < SHOT_MAX; ii++)
	{
		//tOĂāAݒ肵ނԈĂȂ(I[o[t[΍)
		if(tShot[ii].Flag != 0 && 0 <= tShot[ii].Kind && tShot[ii].Kind < SHOT_KND_MAX)
		{
			(this->*ShotBulletPattern[tShot[ii].Kind])(ii); //.knd̒evZ֐ĂԊ֐|C^
			ShotCalc(ii); //iiԖڂ̒evZ
			tShot[ii].Count++;
		}
	}
}
	
//----------------------------------------------------------------
//1A@ɌĒړ
void CBullet::ShotBulletPattern000(int ShotNumber)
{
	int BulletNumber;
	if(tShot[ShotNumber].Count == 0) //en܂0JEg
	{
		//G|ĂȂāATo^\ȒeԍLȂ
		if(tShot[ShotNumber].Flag != 2 && (BulletNumber = ShotSearch(ShotNumber)) != -1)
		{
			tShot[ShotNumber].tBullet[BulletNumber].Kind = EnemyInfo[tShot[ShotNumber].Number].BulletKind2;
			tShot[ShotNumber].tBullet[BulletNumber].Angle = Shotatan2(ShotNumber);
			tShot[ShotNumber].tBullet[BulletNumber].Flag = 1;
			tShot[ShotNumber].tBullet[BulletNumber].Pos.x = EnemyInfo[tShot[ShotNumber].Number].Pos.x;
			tShot[ShotNumber].tBullet[BulletNumber].Pos.z = EnemyInfo[tShot[ShotNumber].Number].Pos.z;
			tShot[ShotNumber].tBullet[BulletNumber].Color = EnemyInfo[tShot[ShotNumber].Number].Color;
			tShot[ShotNumber].tBullet[BulletNumber].Count = 0;
			tShot[ShotNumber].tBullet[BulletNumber].Speed = 0.5f;
		}
	}
}
//----------------------------------------------------------------
//100JEg10A@ɌĒ(Ɏ@_)
void CBullet::ShotBulletPattern001(int ShotNumber)
{
	int BulletNumber;
	int Count = tShot[ShotNumber].Count;
	if(Count >= 0 && Count < 100 && Count % 10 == 0) //100JEg10Ɉ
	{
		if(tShot[ShotNumber].Flag != 2 && (BulletNumber = ShotSearch(ShotNumber)) != -1) //GāAeo^\Ȃ
		{
			tShot[ShotNumber].tBullet[BulletNumber].Kind = EnemyInfo[tShot[ShotNumber].Number].BulletKind2; //eo^
			tShot[ShotNumber].tBullet[BulletNumber].Angle = Shotatan2(ShotNumber); //px
			tShot[ShotNumber].tBullet[BulletNumber].Flag = 1;
			tShot[ShotNumber].tBullet[BulletNumber].Pos.x = EnemyInfo[tShot[ShotNumber].Number].Pos.x;
			tShot[ShotNumber].tBullet[BulletNumber].Pos.z = EnemyInfo[tShot[ShotNumber].Number].Pos.z;
			tShot[ShotNumber].tBullet[BulletNumber].Color = EnemyInfo[tShot[ShotNumber].Number].Color;
			tShot[ShotNumber].tBullet[BulletNumber].Count = 0;
			tShot[ShotNumber].tBullet[BulletNumber].Speed = 0.5f;
		}
	}
}
//----------------------------------------------------------------
//100JEg10AɌĒ(pxL)
void CBullet::ShotBulletPattern002(int ShotNumber)
{
	int BulletNumber;
	int Count = tShot[ShotNumber].Count;
	if(Count >= 0 && Count < 100 && Count % 10 == 0)
	{
		if(Count == 0)
		{
			tShot[ShotNumber].BaseAngle[0] = Shotatan2(ShotNumber);
		}
		if(tShot[ShotNumber].Flag != 2 && (BulletNumber = ShotSearch(ShotNumber)) != -1)
		{
			tShot[ShotNumber].tBullet[BulletNumber].Kind = EnemyInfo[tShot[ShotNumber].Number].BulletKind2;
			tShot[ShotNumber].tBullet[BulletNumber].Angle = tShot[ShotNumber].BaseAngle[0];
			tShot[ShotNumber].tBullet[BulletNumber].Flag = 1;
			tShot[ShotNumber].tBullet[BulletNumber].Pos.x = EnemyInfo[tShot[ShotNumber].Number].Pos.x;
			tShot[ShotNumber].tBullet[BulletNumber].Pos.z = EnemyInfo[tShot[ShotNumber].Number].Pos.z;
			tShot[ShotNumber].tBullet[BulletNumber].Color = EnemyInfo[tShot[ShotNumber].Number].Color;
			tShot[ShotNumber].tBullet[BulletNumber].Count = 0;
			tShot[ShotNumber].tBullet[BulletNumber].Speed = 0.5f;
		}
	}
}
//----------------------------------------------------------------
//100JEg10A@ɌăXs[hω
void CBullet::ShotBulletPattern003(int ShotNumber)
{
	int BulletNumber;
	int Count = tShot[ShotNumber].Count;
	if(Count >= 0 && Count < 100 && Count % 10 == 0)
	{
		if(tShot[ShotNumber].Flag != 2 && (BulletNumber = ShotSearch(ShotNumber)) != -1)
		{
			tShot[ShotNumber].tBullet[BulletNumber].Kind = EnemyInfo[tShot[ShotNumber].Number].BulletKind2;
			tShot[ShotNumber].tBullet[BulletNumber].Angle = Shotatan2(ShotNumber);
			tShot[ShotNumber].tBullet[BulletNumber].Flag = 1;
			tShot[ShotNumber].tBullet[BulletNumber].Pos.x = EnemyInfo[tShot[ShotNumber].Number].Pos.x;
			tShot[ShotNumber].tBullet[BulletNumber].Pos.z = EnemyInfo[tShot[ShotNumber].Number].Pos.z;
			tShot[ShotNumber].tBullet[BulletNumber].Color = EnemyInfo[tShot[ShotNumber].Number].Color;
			tShot[ShotNumber].tBullet[BulletNumber].Count = 0;
			tShot[ShotNumber].tBullet[BulletNumber].Speed = 1 + 2.0f / 100 * Count;
		}
	}
}
//----------------------------------------------------------------
//0.5b1񂸂~`
void CBullet::ShotBulletPattern004(int ShotNumber)
{
	int BulletNumber;
	int Count = tShot[ShotNumber].Count;
	if(Count >= 0 && Count < 120 && Count % 20 == 0)
	{
		float Angle = Shotatan2(ShotNumber);
		for(int ii = 0; ii < 20; ii++)
		{
			if(tShot[ShotNumber].Flag != 2 && (BulletNumber = ShotSearch(ShotNumber)) != -1)
			{
				tShot[ShotNumber].tBullet[BulletNumber].Kind = EnemyInfo[tShot[ShotNumber].Number].BulletKind2; //eo^
				tShot[ShotNumber].tBullet[BulletNumber].Angle = Angle + PI2 / 20 * ii; //px
				tShot[ShotNumber].tBullet[BulletNumber].Flag = 1;
				tShot[ShotNumber].tBullet[BulletNumber].Pos.x = EnemyInfo[tShot[ShotNumber].Number].Pos.x;
				tShot[ShotNumber].tBullet[BulletNumber].Pos.z = EnemyInfo[tShot[ShotNumber].Number].Pos.z;
				tShot[ShotNumber].tBullet[BulletNumber].Color = EnemyInfo[tShot[ShotNumber].Number].Color;
				tShot[ShotNumber].tBullet[BulletNumber].Count = 0;
				tShot[ShotNumber].tBullet[BulletNumber].Speed = 0.6f;
			}
		}
	}
}
//----------------------------------------------------------------
//΂܂Vbg
void CBullet::ShotBulletPattern005(int ShotNumber)
{
	CEnemy enemy;
	int BulletNumber;
	int Count = tShot[ShotNumber].Count;
	if(Count >= 0 && Count < 120 && Count % 20 == 0)
	{
		if(tShot[ShotNumber].Flag != 2 && (BulletNumber = ShotSearch(ShotNumber)) != -1)
		{
			tShot[ShotNumber].tBullet[BulletNumber].Kind = EnemyInfo[tShot[ShotNumber].Number].BulletKind2; //eo^
			tShot[ShotNumber].tBullet[BulletNumber].Angle = Shotatan2(ShotNumber) + enemy.Rang(PI / 4);//px
			tShot[ShotNumber].tBullet[BulletNumber].Flag = 1;
			tShot[ShotNumber].tBullet[BulletNumber].Pos.x = EnemyInfo[tShot[ShotNumber].Number].Pos.x;
			tShot[ShotNumber].tBullet[BulletNumber].Pos.z = EnemyInfo[tShot[ShotNumber].Number].Pos.z;
			tShot[ShotNumber].tBullet[BulletNumber].Color = EnemyInfo[tShot[ShotNumber].Number].Color;
			tShot[ShotNumber].tBullet[BulletNumber].Count = 0;
			tShot[ShotNumber].tBullet[BulletNumber].Speed = 0.5f + enemy.Rang(1.5);
		}
	}
}
//----------------------------------------------------------------
//΂܂Vbg()
void CBullet::ShotBulletPattern006(int ShotNumber)
{
	CEnemy enemy;
	int BulletNumber;
	int Count = tShot[ShotNumber].Count;
	if(Count >= 0 && Count < 120 && Count % 2 == 0)
	{
		if(tShot[ShotNumber].Flag != 2 && (BulletNumber = ShotSearch(ShotNumber)) != -1)
		{
			tShot[ShotNumber].tBullet[BulletNumber].Kind = EnemyInfo[tShot[ShotNumber].Number].BulletKind2; //eo^
			tShot[ShotNumber].tBullet[BulletNumber].Angle = Shotatan2(ShotNumber) + enemy.Rang(PI / 4);//px
			tShot[ShotNumber].tBullet[BulletNumber].Flag = 1;
			tShot[ShotNumber].tBullet[BulletNumber].Pos.x = EnemyInfo[tShot[ShotNumber].Number].Pos.x;
			tShot[ShotNumber].tBullet[BulletNumber].Pos.z = EnemyInfo[tShot[ShotNumber].Number].Pos.z;
			tShot[ShotNumber].tBullet[BulletNumber].Color = EnemyInfo[tShot[ShotNumber].Number].Color;
			tShot[ShotNumber].tBullet[BulletNumber].Count = 0;
			tShot[ShotNumber].tBullet[BulletNumber].Speed = 0.6f + enemy.Rang(2);
		}
	}
	for(int ii = 0; ii < SHOT_BULLET_MAX; ii++)
	{
		if(tShot[ShotNumber].tBullet[ii].Speed > 1.5)
		{
			tShot[ShotNumber].tBullet[ii].Speed -= 0.04; //
		}
	}
}
//----------------------------------------------------------------
void CBullet::ShotCalc(int ShotNumber)
{
	int Max = 0;
	//G|ꂽ
	if(EnemyInfo[tShot[ShotNumber].Number].Flag != 1)
	{
		tShot[ShotNumber].Flag = 2; //ȏVbgo^Ȃ
	}
	//ShotNumberԖڂ̒ef[^̒evZ
	for(int ii = 0; ii < SHOT_BULLET_MAX; ii++)
	{
		//̒eo^Ă
		if(tShot[ShotNumber].tBullet[ii].Flag > 0)
		{
			tShot[ShotNumber].tBullet[ii].Pos.x += cos(tShot[ShotNumber].tBullet[ii].Angle) * tShot[ShotNumber].tBullet[ii].Speed;
			tShot[ShotNumber].tBullet[ii].Pos.z += sin(tShot[ShotNumber].tBullet[ii].Angle) * tShot[ShotNumber].tBullet[ii].Speed;
			tShot[ShotNumber].tBullet[ii].Count++;
			if(tShot[ShotNumber].tBullet[ii].Pos.x < 248 || tShot[ShotNumber].tBullet[ii].Pos.x > 390 ||
				tShot[ShotNumber].tBullet[ii].Pos.z < 170 || tShot[ShotNumber].tBullet[ii].Pos.z > 325)
			{
				tShot[ShotNumber].tBullet[ii].Flag = 0;
			}
		}
	}
	//ݕ\̒eł邩ׂ
	for(int ii = 0; ii < SHOT_BULLET_MAX; ii++)
	{
		if(tShot[ShotNumber].tBullet[ii].Flag > 0)
		{
			return;
		}
	}
	if(EnemyInfo[tShot[ShotNumber].Number].Flag != 1)
	{
		tShot[ShotNumber].Flag = 0; //I
		EnemyInfo[tShot[ShotNumber].Number].Flag = 0;
	}
}
//----------------------------------------------------------------
void CBullet::DrawShot()
{
	 SetDrawMode(DX_DRAWMODE_BILINEAR);//`⊮`
	 for(int ii = 0; ii < SHOT_MAX; ii++)
	 {
		 if(tShot[ii].Flag > 0)
		 {
			 for(int jj = 0; jj < SHOT_BULLET_MAX; jj++)
			 {
				 if(tShot[ii].tBullet[jj].Flag != 0)
				 {
					 if(tShot[ii].tBullet[jj].Effect == 1)
					 {
						 SetDrawBlendMode(DX_BLENDMODE_ADD, 255);
					 }
					 /*DrawBillboard3D(tShot[ii].tBullet[jj].Pos, tShot[ii].tBullet[jj].Pos.x + PLAYER_MOVEX_MIN,
						 tShot[ii].tBullet[jj].Pos.z, 1.0f, tShot[ii].tBullet[jj].Angle + PI/2, BulletImage[tShot[ii].tBullet[jj].Kind][tShot[ii].tBullet[jj].Color], TRUE);*/
					 int SizeX, SizeY;
					 int BulletHandle;
					 BulletHandle = BulletImage[tShot[ii].tBullet[jj].Kind][tShot[ii].tBullet[jj].Color];
					 GetGraphSize(BulletHandle, &SizeX, &SizeY);
					 DrawBillboard3D(tShot[ii].tBullet[jj].Pos, 0.5f, 0.5f, (float)SizeX / 4.0f, 0.0f, BulletHandle, TRUE);
					 if(tShot[ii].tBullet[jj].Effect == 1)
					 {
						 SetDrawBlendMode(DX_BLENDMODE_NOBLEND, 0);
					 }
				 }
			 }
		 }
	}
	 SetDrawMode(DX_DRAWMODE_NEAREST); //``߂
}
//------------------------------------------------------------
CBullet::SHOT_PARAM* CBullet::GetShotParam()
{
	return tShot;
}
//----------------------------------------------------------------
void CBullet::ShotEntry(int EnemyNumber)
{
	for(int ii = 0; ii < SHOT_MAX; ii++)
	{
		if(tShot[ii].Flag == 0)
		{
			memset(&tShot[ii], 0, sizeof(SHOT_PARAM));
			for(int jj = 0; jj < SHOT_BULLET_MAX; jj++)
			{
				tShot[ii].tBullet[jj].Pos.y = -280.0f;
			}
			tShot[ii].Flag = 1;
			tShot[ii].Kind = EnemyInfo[EnemyNumber].BulletKind;
			tShot[ii].Number = ii;
			tShot[ii].Count = 0;
			return;
		}
	}
}