#include "CheckHit.h"

//---------------------------------------------------------
CCheckHit::CCheckHit()
{
}
//---------------------------------------------------------
CCheckHit::~CCheckHit()
{}
//---------------------------------------------------------
void CCheckHit::InputBulletInfo(CCheckHit::BULLET_INFO *tBulletInfo, int sizeX, int sizeY, int ColorNumber, float range)
{
	tBulletInfo->SizeX = sizeX;
	tBulletInfo->SizeY = sizeY;
	tBulletInfo->ColorNumber = ColorNumber;
	tBulletInfo->Range = range;
}
//---------------------------------------------------------
void CCheckHit::Init()
{
	 InputBulletInfo(&tBulletInfo[0],76, 76, 5,17.0);
     InputBulletInfo(&tBulletInfo[1],22, 22, 6, 4.0);
     InputBulletInfo(&tBulletInfo[2], 5,120,10, 2.5);
     InputBulletInfo(&tBulletInfo[3],19, 34, 5, 2.0);
     InputBulletInfo(&tBulletInfo[4],38, 38,10, 2.0);
     InputBulletInfo(&tBulletInfo[5],14, 16, 3, 3.5);
     InputBulletInfo(&tBulletInfo[6],14, 18, 3, 2.0);
     InputBulletInfo(&tBulletInfo[7],16, 16, 9, 2.5);
     InputBulletInfo(&tBulletInfo[8],12, 18,10, 1.5);
     InputBulletInfo(&tBulletInfo[9],13, 19, 3, 2.0);
}
//----------------------------------------------------------------
void CCheckHit::SetPlayerParam(CModel::PLAYER_PARAM player)
{
	PlayerInfo = player;
}
//----------------------------------------------------------------
void CCheckHit::SetShotParam(CBullet::SHOT_PARAM *shot)
{
	ShotInfo = shot;
}
//---------------------------------------------------------
int CCheckHit::OutJudgeEnemyShot(int ShotNumber, int BulletNumber)
{
	//Vbg̋OxłvZĂ
	if(ShotInfo[ShotNumber].tBullet[BulletNumber].Count > 0)
	{
		float x = ShotInfo[ShotNumber].tBullet[BulletNumber].Pos.x - PlayerInfo.PlayerPos.x; //GƎ@VbgƂ̋
		float z = ShotInfo[ShotNumber].tBullet[BulletNumber].Pos.z - PlayerInfo.PlayerPos.z;
		//I[o[t[΍
		if(ShotInfo[ShotNumber].tBullet[BulletNumber].Kind >= 10)
		{
			printfDx("OutJudgeEnemyShotI[o[t[\n");
		}
		//GVbgƎ@̓蔻̍v͈
		float Range = tBulletInfo[ShotInfo[ShotNumber].tBullet[BulletNumber].Kind].Range + CRANGE;
		//ԂvZKv
		if(ShotInfo[ShotNumber].tBullet[BulletNumber].Speed > Range)
		{
			//1t[Oɂʒui[
			float Pre_X = ShotInfo[ShotNumber].tBullet[BulletNumber].Pos.x + cos(ShotInfo[ShotNumber].tBullet[BulletNumber].Angle + PI) * ShotInfo[ShotNumber].tBullet[BulletNumber].Speed;
			float Pre_Z = ShotInfo[ShotNumber].tBullet[BulletNumber].Pos.z + sin(ShotInfo[ShotNumber].tBullet[BulletNumber].Angle + PI) * ShotInfo[ShotNumber].tBullet[BulletNumber].Speed;
			float PX, PZ;
			//i񂾕/蔻蕪[v
			for(int jj = 0; jj < ShotInfo[ShotNumber].tBullet[BulletNumber].Speed / Range; jj++)
			{
				PX = Pre_X - PlayerInfo.PlayerPos.x;
				PZ = Pre_Z - PlayerInfo.PlayerPos.z;
				if(PX * PX + PZ * PZ < Range * Range)
				{
					return 1;
				}
				Pre_X += cos(ShotInfo[ShotNumber].tBullet[BulletNumber].Angle) * Range;
				Pre_Z += sin(ShotInfo[ShotNumber].tBullet[BulletNumber].Angle) * Range;
			}
		}
		//蔻Ȃ
		if(x * x + z * z < Range * Range)
		{
			return 1; //
		}
	}
	return 0;
}
//---------------------------------------------------------
//GVbgƎ@Ƃ̏
void CCheckHit::EnemyShotAndPlayer()
{
	//GVbg
	for(int ii = 0; ii < SHOT_MAX; ii++)
	{
		//̃Vbgo^Ă
		if(ShotInfo[ii].Flag > 0)
		{
			//e
			for(int jj = 0; jj < SHOT_BULLET_MAX; jj++)
			{
				//eo^Ă
				if(ShotInfo[ii].tBullet[jj].Flag == 1)
				{
					//@ɂ̒eڐGĂ
					if(OutJudgeEnemyShot(ii, jj))
					{
						ShotInfo[ii].tBullet[jj].Flag = 0; //eIt
						//Xe[^XʏŁAGȂ
						if(PlayerInfo.PlayerFlag == 0 && PlayerInfo.MutekiCount == 0)
						{
							PlayerInfo.PlayerFlag = 2;
							PlayerInfo.Count = 0;
							return;
						}
					}
				}
			}
		}
	}
}
//---------------------------------------------------------
int CCheckHit::GetPlayerFlag()
{
	return PlayerInfo.PlayerFlag;
}