#include "DxLib.h"
#include "Input.h"
#include "Stage.h"
#include "Camera.h"
#include "Model.h"
#include "Enemy.h"
//#include "Bullet.h"
#include "CheckHit.h"
#include <stdio.h>
#include <string.h>
#include <iostream>
using namespace std;

#define ISLAND (0)
#define MIKU (0)
#define BACK (1)
#define SCREENWIDTH (1280)
#define SCREENHIGH (720)
#define SCREENBIT (32)
const int MaxStage = 2;
typedef struct CAMERA_DATA;

int WINAPI WinMain(HINSTANCE,HINSTANCE,LPSTR,int)
{
		ChangeWindowMode(TRUE);
		SetGraphMode(SCREENWIDTH ,SCREENHIGH ,SCREENBIT);	// ʃ[h̐ݒ
        // DXCu
		if( DxLib_Init() < 0 )
		{
			// G[璼ɏI
			return -1 ;
		}
		SetDrawScreen( DX_SCREEN_BACK );
		int StageCount = 0;
		CInput* input = new CInput();
		//J̐ݒ
		CCamera* camera = new CCamera();
		CCamera::CAMERA_DATA CameraInfo;
		//JZʏɂȂ悤7A8A9̂Z̑91.0ɂ(ʏYȂ̂ő81.0)
		camera->CameraInit(320.0f, -110.0f,  220.0f, 320.0f, -280.0f, 240.0f, 0.0f, 0.0f, 1.0f);
		CameraInfo = camera->GetCameraParam();
		camera->CameraSet(CameraInfo);
		//f̏ݒ
		CModel* model = new CModel();
		CModel::PLAYER_PARAM PlayerInfo; 
		model->LoadFile(MIKU, "PlayerModel/Miku/Miku.mv1");					//LN^[̃f̓ǂݍ
		model->SetPlayerRoll(MIKU, 90.0f, 0.0f, 0.0f);					//vC[f̏]l
		model->SetPlayerPos(MIKU, 320.0f, -280.0f, 177.0f);								//vC[f̏ʒu
		PlayerInfo = model->GetPlayerParam();												// `𗠉ʂɂ
		//ÂAj[V폜
		model->EraseAnimInfo(PlayerInfo);
		//Aj[V
		model->InitAnime(PlayerInfo.NowAnimNum, PlayerInfo.PlayerModel[MIKU], 0);
		PlayerInfo.AnimeState = CModel::WAIT;
		model->SetAnimeInfo(PlayerInfo);
		//G̐ݒ
		CEnemy* enemy = new CEnemy();
		CEnemy::ENEMY_PARAM* EnemyState;
		CBullet::SHOT_PARAM* ShotState;
		enemy->LoadEnemyOrder();
		enemy->LoadEnemy(CEnemy::ENEMY0, "Enemy/enemy1.x");
		//e̐ݒ
		bullet = new CBullet();
		bullet->LoadBullet();
		CCheckHit *checkhit = new CCheckHit();
		checkhit->Init();
		//2Dǂݍ
		int SideBar = LoadGraph("Graphic/Dammy.png");
		while(ScreenFlip() == 0 && ProcessMessage() == 0 && ClearDrawScreen() == 0  && input->gpUpdateKey() == 0)
		{
			input->UpdatePad();
			//L̈ړ
			/*if(input->TriggerPad & PAD_INPUT_RIGHT)
			{
				PlayerInfo.PlayerPos.x -= 10;
			}
			else if(input->TriggerPad & PAD_INPUT_LEFT)
			{
				PlayerInfo.PlayerPos.x += 10;
			}
			else if(input->TriggerPad & PAD_INPUT_UP)
			{
				PlayerInfo.PlayerPos.z += 10;
			}
			else if(input->TriggerPad & PAD_INPUT_DOWN)
			{
				PlayerInfo.PlayerPos.z -= 10;
			}
			else if(input->Key1[KEY_INPUT_RETURN] != 0)
			{
				PlayerInfo.PlayerPos.y += 10;
			}
			else if(input->Key1[KEY_INPUT_BACK] != 0)
			{
				PlayerInfo.PlayerPos.y -= 10;
			}
			else if(input->Key1[KEY_INPUT_SPACE] != 0)
			{
				break;
			}
			model->SetPlayerPos(MIKU, PlayerInfo.PlayerPos.x, PlayerInfo.PlayerPos.y, PlayerInfo.PlayerPos.z);*/
			model->GetCenterPos();
			model->SetMoveAngle();
			model->MovePlayerModel();
			model->DrawModel(MIKU);
			enemy->EnemyEntery(StageCount);
			enemy->EnemyAction();
			enemy->EnemyDrow(CEnemy::ENEMY0);
			PlayerInfo = model->GetPlayerParam();
			EnemyState = enemy->GetEnemyParam();
			ShotState = bullet->GetShotParam();
			bullet->SetPlayerParam(PlayerInfo);
			bullet->SetEnemyParam(EnemyState);
			bullet->ShotMain();
			bullet->DrawShot();
			checkhit->SetPlayerParam(PlayerInfo);
			checkhit->SetShotParam(ShotState);
			checkhit->EnemyShotAndPlayer();
			model->SetPlayerFlag(checkhit->GetPlayerFlag());
			DrawGraph(0, 0, SideBar, TRUE);
			DrawGraph(1000, 0, SideBar, TRUE);
			DrawFormatString(100, 340, 0x666666,"X %f Y %f Z %f", PlayerInfo.PlayerPos.x, PlayerInfo.PlayerPos.y, PlayerInfo.PlayerPos.z);
			StageCount++;
		}
		model->UnLoadModel(MIKU);
		delete model;
        WaitKey();      // L[͑҂
        DxLib_End();    // DXCuI
        return 0;
}