#ifndef CHECKHITH
#define CHECKHITH

#include "Bullet.h"

#define ENEMY_RANGE_MAX (4)
#define CSHOT_RANGE_MAX (2)
#define CRANGE (0.5f)

class CCheckHit
{
public:
	typedef struct
	{
		int SizeX;
		int SizeY;
		int ColorNumber;
		float Range;
	}BULLET_INFO;
private:
	BULLET_INFO tBulletInfo[10];//e
	CBullet::SHOT_PARAM *ShotInfo;
	CModel::PLAYER_PARAM PlayerInfo;
public:
	CCheckHit();
	~CCheckHit();
	void Init();
	void InputBulletInfo(BULLET_INFO* tBulletInfo, int sizeX, int sizeY, int ColorNumber, float range);
	int OutJudgeEnemyShot(int ShotNumber, int BulletNumber);
	void EnemyShotAndPlayer();
	int GetPlayerFlag();
	void SetPlayerParam(CModel::PLAYER_PARAM player);
	void SetShotParam(CBullet::SHOT_PARAM *shot);
};

#endif